//+------------------------------------------------------------------+
//|                                                     hgi_indi.mqh |
//|                                http://www.stevehopwoodforex.com/ |
//| This library was developed by milanese from the                  |
//|    http://www.stevehopwoodforex.com/ forum.                      |
//+------------------------------------------------------------------+
#property copyright "renexxxx"
#property link      "http://www.stevehopwoodforex.com/"
#property strict

input     string    hgi_indicator = "HGI_v16.09";

enum SIGNAL {
   NONE=0,
   TRENDUP=1,
   TRENDDN=2,
   RANGEUP=3,
   RANGEDN=4,
   RADUP=5,
   RADDN=6 };
   
enum SLOPE {
   UNDEFINED=0,
   RANGEABOVE=1,
   RANGEBELOW=2,
   TRENDABOVE=3,
   TRENDBELOW=4 };
   
SIGNAL getHGISignal( string symbol, int timeframe, int shift ) {

   SIGNAL mySignal = NONE;

   for(int iBuffer=0; iBuffer < 6; iBuffer++) {
      double indiValue = iCustom(symbol, timeframe, hgi_indicator, true, iBuffer, shift);
      
      if ( indiValue  != EMPTY_VALUE ) {
         mySignal = (SIGNAL)(iBuffer+1);
         break;
      }
   }
   return(mySignal);
}

SLOPE getHGISlope( string symbol, int timeframe, int shift ) {

   SLOPE mySlope = UNDEFINED;

   for(int iBuffer=6; iBuffer < 8; iBuffer++) {
      double indiValue = iCustom(symbol, timeframe, hgi_indicator, true, iBuffer, shift);
      bool   indiAbove = ( iHigh(symbol, timeframe, shift) < indiValue );

      if ( indiValue  != EMPTY_VALUE ) {

         switch(iBuffer) {
            case 6: mySlope = ( indiAbove ) ? RANGEABOVE : RANGEBELOW ; break;
            case 7: mySlope = ( indiAbove ) ? TRENDABOVE : TRENDBELOW ; break;
         }
         break;
      }
   }
   return(mySlope);
}